﻿
#load "References.fsx"

  
let rep x p = 
  let rec mkArgs (i: Int) =
    x + i.ToString () + (if i = 0 then "" else " " + mkArgs (i-1))
  mkArgs p

let fLine n i = 
  sprintf "F%d f %s = F%d (F%d f) %s." i (rep "x" (max 0 (n-2))) (i+1) (i+1) (rep "x" (max 0 (n-2)))

let gLine n i =
  sprintf "G%d f z %s = f (f z) %s." i (rep "x" (max 0 (i-3))) (rep "x" (max 0 (i-3)))

let fLines n m =
  seq { for i in 0 .. m -> fLine n i }

let gLines n m =
  seq { for i in 3 .. n -> gLine n i }

let sLine n = sprintf "S = F0 %s." (rep "G" (n-1))
let lastFLine n m = sprintf "F%d f %s = G%d f %s." (m+1) (rep "x" (max 0 (n-2))) n (rep "x" (max 0 (n-2)))

let mkExp (n: Int) (m: Int) : String =
  let xs =
      ["%BEGING"]
      @  [sLine n] 
      @ List.ofSeq (fLines n m) 
      @ [lastFLine n m] 
      @ List.ofSeq (gLines n m) 
      @ ["G2 f z = f (f z)."; "G1 z = a z."; "G0 = c."]
      @ ["%ENDG"]
      @ ["%BEGINA"]
      @ ["q0 a -> q1."; "q1 a -> q0."; "q0 c -> ."]
      @ ["%ENDA"]
  let ys = List.intersperse xs "\n"
  List.fold (fun s x -> s + x) "" ys

let writeExp dir n m =
  let fn = sprintf "exp%d-%d.hrs" n m
  let fp = System.IO.Path.Combine (dir, fn)
  let tx = mkExp n m
  System.IO.File.WriteAllText (fp, tx)

writeExp @"C:\Users\steven\SkyDrive\Projects\HORSBenchmarks\GTRecS" 5 6400

