// Implementation file for parser generated by fsyacc
module HORSSyntax.HORSParser
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 2 "HORSParser.fsy"


open Microsoft.FSharp.Text.Parsing

exception ParseError of String * Int32 * Int32

//exception ParseError of string * (int list) * (int list list) * (int list) * (int list)

//let parse_error_rich = Some (fun (ctxt: ParseErrorContext<_>)
//                               -> raise (ParseError
//                                              (ctxt.Message,
//                                               ctxt.ReduceTokens,
//                                               ctxt.ReducibleProductions,
//                                               ctxt.ShiftTokens,
//                                               ctxt.StateStack)))

let horsSize : Ref<Int> = ref 0

let dataItems : HashSet<Int> = HashSet()

let mkIdent (s: String, pos: Position) : SynIdent =
  horsSize := !horsSize + 1
  {
    Str = s
    Pos = (pos.FileName, pos.Line, pos.Column + 1)
  }

let mkData (n: Int, pos: Position) : SynIdent =
  do ignore (dataItems.Add n)
  mkIdent (n.ToString (), pos)

let mkDetTrans (q: SynState) (a: SynIdent) (xs: List<SynState>) =
  
  let enumerate (ys: List<Int * SynState>, i: Int) (q': SynState) : List<Int * SynState> * Int =
    ((i, q') :: ys, i+1)

  let qs, _ = List.fold enumerate ([], 1) xs

  {
    State = q
    Symbol = a
    Succs = qs
  }

let reportError (p: IParseState) (s: String) (n: Int) =
  let posn = p.InputStartPosition n
  raise (ParseError (s, posn.Line, posn.Column + 1))

let mkPrio (p: IParseState) (q: SynState) (n: SynIdent) : SynState * Int =
  match System.Int32.TryParse n.Str with
  | true, m -> (q, m)
  | false, _ ->
      if n.Str = "A" then (q, 2)
      elif n.Str = "R" then (q, 1)
      else
        reportError p "expected an integer, 'R' or 'A' as priority." 3

let mkPAuto (ts: List<SynTransition>) : SynPAutomaton =
  let statesOfTransition t = t.State :: List.map snd t.Succs
  let ps = List.collect statesOfTransition ts
           |> List.nub
           |> List.map (fun x -> (x,2))
  { Priorities = ps; Transitions = ts }


# 72 "HORSParser.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | EOF
  | BEGING
  | ENDG
  | BEGINA
  | ENDA
  | BEGINP
  | ENDP
  | LPAREN
  | RPAREN
  | NEWLINE
  | COMMA
  | STOP
  | RIGHTARROW
  | EQUALS
  | CASE
  | INT of (Int32)
  | ID of (String)
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_EOF
    | TOKEN_BEGING
    | TOKEN_ENDG
    | TOKEN_BEGINA
    | TOKEN_ENDA
    | TOKEN_BEGINP
    | TOKEN_ENDP
    | TOKEN_LPAREN
    | TOKEN_RPAREN
    | TOKEN_NEWLINE
    | TOKEN_COMMA
    | TOKEN_STOP
    | TOKEN_RIGHTARROW
    | TOKEN_EQUALS
    | TOKEN_CASE
    | TOKEN_INT
    | TOKEN_ID
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startTInstance
    | NONTERM__startPInstance
    | NONTERM_PInstance
    | NONTERM_TInstance
    | NONTERM_Hors
    | NONTERM_HorsRules
    | NONTERM_HorsRule
    | NONTERM_Vars
    | NONTERM_Term
    | NONTERM_Exp
    | NONTERM_Priority
    | NONTERM_Priorities
    | NONTERM_Automaton
    | NONTERM_Transitions
    | NONTERM_Transition
    | NONTERM_IntStatePairs
    | NONTERM_IntStatePair
    | NONTERM_States
    | NONTERM_Ident
    | NONTERM_Case
    | NONTERM_Alternatives
    | NONTERM_Recover

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | EOF  -> 0 
  | BEGING  -> 1 
  | ENDG  -> 2 
  | BEGINA  -> 3 
  | ENDA  -> 4 
  | BEGINP  -> 5 
  | ENDP  -> 6 
  | LPAREN  -> 7 
  | RPAREN  -> 8 
  | NEWLINE  -> 9 
  | COMMA  -> 10 
  | STOP  -> 11 
  | RIGHTARROW  -> 12 
  | EQUALS  -> 13 
  | CASE  -> 14 
  | INT _ -> 15 
  | ID _ -> 16 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_EOF 
  | 1 -> TOKEN_BEGING 
  | 2 -> TOKEN_ENDG 
  | 3 -> TOKEN_BEGINA 
  | 4 -> TOKEN_ENDA 
  | 5 -> TOKEN_BEGINP 
  | 6 -> TOKEN_ENDP 
  | 7 -> TOKEN_LPAREN 
  | 8 -> TOKEN_RPAREN 
  | 9 -> TOKEN_NEWLINE 
  | 10 -> TOKEN_COMMA 
  | 11 -> TOKEN_STOP 
  | 12 -> TOKEN_RIGHTARROW 
  | 13 -> TOKEN_EQUALS 
  | 14 -> TOKEN_CASE 
  | 15 -> TOKEN_INT 
  | 16 -> TOKEN_ID 
  | 19 -> TOKEN_end_of_input
  | 17 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startTInstance 
    | 1 -> NONTERM__startPInstance 
    | 2 -> NONTERM_PInstance 
    | 3 -> NONTERM_PInstance 
    | 4 -> NONTERM_PInstance 
    | 5 -> NONTERM_PInstance 
    | 6 -> NONTERM_PInstance 
    | 7 -> NONTERM_PInstance 
    | 8 -> NONTERM_PInstance 
    | 9 -> NONTERM_PInstance 
    | 10 -> NONTERM_PInstance 
    | 11 -> NONTERM_TInstance 
    | 12 -> NONTERM_TInstance 
    | 13 -> NONTERM_TInstance 
    | 14 -> NONTERM_TInstance 
    | 15 -> NONTERM_TInstance 
    | 16 -> NONTERM_Hors 
    | 17 -> NONTERM_HorsRules 
    | 18 -> NONTERM_HorsRules 
    | 19 -> NONTERM_HorsRules 
    | 20 -> NONTERM_HorsRule 
    | 21 -> NONTERM_HorsRule 
    | 22 -> NONTERM_HorsRule 
    | 23 -> NONTERM_HorsRule 
    | 24 -> NONTERM_HorsRule 
    | 25 -> NONTERM_Vars 
    | 26 -> NONTERM_Vars 
    | 27 -> NONTERM_Term 
    | 28 -> NONTERM_Term 
    | 29 -> NONTERM_Exp 
    | 30 -> NONTERM_Exp 
    | 31 -> NONTERM_Exp 
    | 32 -> NONTERM_Exp 
    | 33 -> NONTERM_Priority 
    | 34 -> NONTERM_Priorities 
    | 35 -> NONTERM_Priorities 
    | 36 -> NONTERM_Priorities 
    | 37 -> NONTERM_Automaton 
    | 38 -> NONTERM_Transitions 
    | 39 -> NONTERM_Transitions 
    | 40 -> NONTERM_Transitions 
    | 41 -> NONTERM_Transition 
    | 42 -> NONTERM_Transition 
    | 43 -> NONTERM_Transition 
    | 44 -> NONTERM_IntStatePairs 
    | 45 -> NONTERM_IntStatePairs 
    | 46 -> NONTERM_IntStatePair 
    | 47 -> NONTERM_IntStatePair 
    | 48 -> NONTERM_IntStatePair 
    | 49 -> NONTERM_IntStatePair 
    | 50 -> NONTERM_IntStatePair 
    | 51 -> NONTERM_States 
    | 52 -> NONTERM_States 
    | 53 -> NONTERM_Ident 
    | 54 -> NONTERM_Ident 
    | 55 -> NONTERM_Case 
    | 56 -> NONTERM_Alternatives 
    | 57 -> NONTERM_Alternatives 
    | 58 -> NONTERM_Alternatives 
    | 59 -> NONTERM_Alternatives 
    | 60 -> NONTERM_Recover 
    | 61 -> NONTERM_Recover 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 19 
let _fsyacc_tagOfErrorTerminal = 17

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | EOF  -> "EOF" 
  | BEGING  -> "BEGING" 
  | ENDG  -> "ENDG" 
  | BEGINA  -> "BEGINA" 
  | ENDA  -> "ENDA" 
  | BEGINP  -> "BEGINP" 
  | ENDP  -> "ENDP" 
  | LPAREN  -> "LPAREN" 
  | RPAREN  -> "RPAREN" 
  | NEWLINE  -> "NEWLINE" 
  | COMMA  -> "COMMA" 
  | STOP  -> "STOP" 
  | RIGHTARROW  -> "RIGHTARROW" 
  | EQUALS  -> "EQUALS" 
  | CASE  -> "CASE" 
  | INT _ -> "INT" 
  | ID _ -> "ID" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | EOF  -> (null : System.Object) 
  | BEGING  -> (null : System.Object) 
  | ENDG  -> (null : System.Object) 
  | BEGINA  -> (null : System.Object) 
  | ENDA  -> (null : System.Object) 
  | BEGINP  -> (null : System.Object) 
  | ENDP  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | RPAREN  -> (null : System.Object) 
  | NEWLINE  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | STOP  -> (null : System.Object) 
  | RIGHTARROW  -> (null : System.Object) 
  | EQUALS  -> (null : System.Object) 
  | CASE  -> (null : System.Object) 
  | INT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ID _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 0us; 65535us; 1us; 65535us; 2us; 3us; 1us; 65535us; 0us; 1us; 2us; 65535us; 4us; 5us; 25us; 26us; 3us; 65535us; 4us; 35us; 25us; 35us; 37us; 38us; 3us; 65535us; 4us; 36us; 25us; 36us; 37us; 36us; 2us; 65535us; 40us; 41us; 49us; 50us; 6us; 65535us; 42us; 43us; 45us; 46us; 54us; 55us; 58us; 59us; 99us; 100us; 103us; 104us; 6us; 65535us; 42us; 51us; 45us; 51us; 54us; 51us; 58us; 51us; 99us; 51us; 103us; 51us; 3us; 65535us; 7us; 64us; 18us; 64us; 65us; 64us; 3us; 65535us; 7us; 8us; 18us; 19us; 65us; 66us; 3us; 65535us; 10us; 11us; 15us; 16us; 28us; 29us; 4us; 65535us; 10us; 68us; 15us; 68us; 28us; 68us; 70us; 71us; 4us; 65535us; 10us; 69us; 15us; 69us; 28us; 69us; 70us; 69us; 2us; 65535us; 75us; 76us; 79us; 80us; 2us; 65535us; 75us; 79us; 79us; 79us; 2us; 65535us; 75us; 77us; 90us; 91us; 27us; 65535us; 4us; 40us; 7us; 61us; 10us; 73us; 15us; 73us; 18us; 61us; 25us; 40us; 28us; 73us; 37us; 40us; 40us; 49us; 42us; 53us; 45us; 53us; 49us; 49us; 51us; 57us; 54us; 53us; 58us; 53us; 62us; 63us; 65us; 61us; 70us; 73us; 73us; 74us; 75us; 90us; 83us; 84us; 90us; 90us; 95us; 96us; 96us; 98us; 97us; 102us; 99us; 53us; 103us; 53us; 6us; 65535us; 42us; 52us; 45us; 52us; 54us; 52us; 58us; 52us; 99us; 52us; 103us; 52us; 1us; 65535us; 96us; 97us; 21us; 65535us; 0us; 34us; 2us; 24us; 4us; 23us; 5us; 22us; 6us; 21us; 7us; 14us; 8us; 13us; 25us; 33us; 26us; 32us; 27us; 31us; 36us; 39us; 41us; 48us; 42us; 44us; 45us; 47us; 64us; 67us; 69us; 72us; 74us; 78us; 81us; 89us; 82us; 88us; 83us; 87us; 84us; 86us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 2us; 4us; 6us; 9us; 13us; 17us; 20us; 27us; 34us; 38us; 42us; 46us; 51us; 56us; 59us; 62us; 65us; 93us; 100us; 102us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 8us; 2us; 3us; 4us; 5us; 6us; 7us; 8us; 9us; 7us; 2us; 3us; 4us; 5us; 6us; 7us; 8us; 6us; 2us; 3us; 4us; 5us; 6us; 7us; 3us; 2us; 3us; 4us; 2us; 2us; 3us; 1us; 2us; 1us; 2us; 1us; 2us; 1us; 2us; 1us; 3us; 1us; 4us; 2us; 5us; 6us; 2us; 5us; 6us; 2us; 5us; 6us; 1us; 5us; 1us; 5us; 1us; 5us; 1us; 7us; 1us; 8us; 1us; 9us; 1us; 10us; 4us; 11us; 12us; 13us; 14us; 3us; 11us; 12us; 13us; 2us; 11us; 12us; 1us; 11us; 1us; 11us; 1us; 11us; 1us; 12us; 1us; 13us; 1us; 14us; 1us; 15us; 1us; 16us; 3us; 17us; 18us; 19us; 2us; 17us; 18us; 1us; 17us; 1us; 19us; 5us; 20us; 21us; 22us; 23us; 24us; 5us; 20us; 21us; 22us; 23us; 24us; 2us; 20us; 21us; 1us; 20us; 1us; 21us; 2us; 22us; 23us; 1us; 22us; 1us; 23us; 1us; 24us; 1us; 26us; 1us; 26us; 3us; 27us; 31us; 32us; 1us; 28us; 1us; 29us; 1us; 30us; 1us; 30us; 1us; 30us; 1us; 31us; 1us; 32us; 1us; 32us; 1us; 32us; 1us; 33us; 1us; 33us; 1us; 33us; 3us; 34us; 35us; 36us; 2us; 34us; 35us; 1us; 34us; 1us; 36us; 1us; 37us; 3us; 38us; 39us; 40us; 2us; 38us; 39us; 1us; 38us; 1us; 40us; 3us; 41us; 42us; 43us; 3us; 41us; 42us; 43us; 2us; 41us; 42us; 1us; 41us; 1us; 42us; 1us; 43us; 1us; 45us; 1us; 45us; 5us; 46us; 47us; 48us; 49us; 50us; 4us; 46us; 47us; 48us; 49us; 3us; 46us; 47us; 48us; 2us; 46us; 47us; 1us; 46us; 1us; 47us; 1us; 48us; 1us; 49us; 1us; 50us; 2us; 51us; 52us; 1us; 51us; 1us; 53us; 1us; 54us; 1us; 55us; 1us; 55us; 1us; 55us; 3us; 55us; 58us; 59us; 1us; 56us; 1us; 57us; 1us; 57us; 1us; 57us; 1us; 58us; 1us; 59us; 1us; 59us; 1us; 59us; 1us; 60us; 1us; 61us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 17us; 25us; 32us; 36us; 39us; 41us; 43us; 45us; 47us; 49us; 51us; 54us; 57us; 60us; 62us; 64us; 66us; 68us; 70us; 72us; 74us; 79us; 83us; 86us; 88us; 90us; 92us; 94us; 96us; 98us; 100us; 102us; 106us; 109us; 111us; 113us; 119us; 125us; 128us; 130us; 132us; 135us; 137us; 139us; 141us; 143us; 145us; 149us; 151us; 153us; 155us; 157us; 159us; 161us; 163us; 165us; 167us; 169us; 171us; 173us; 177us; 180us; 182us; 184us; 186us; 190us; 193us; 195us; 197us; 201us; 205us; 208us; 210us; 212us; 214us; 216us; 218us; 224us; 229us; 233us; 236us; 238us; 240us; 242us; 244us; 246us; 249us; 251us; 253us; 255us; 257us; 259us; 261us; 265us; 267us; 269us; 271us; 273us; 275us; 277us; 279us; 281us; 283us; |]
let _fsyacc_action_rows = 108
let _fsyacc_actionTableElements = [|3us; 32768us; 0us; 107us; 1us; 25us; 17us; 106us; 0us; 49152us; 3us; 32768us; 0us; 107us; 1us; 4us; 17us; 106us; 0us; 49152us; 4us; 32768us; 0us; 107us; 15us; 93us; 16us; 92us; 17us; 106us; 3us; 32768us; 0us; 107us; 2us; 6us; 17us; 106us; 4us; 32768us; 0us; 107us; 3us; 15us; 5us; 7us; 17us; 106us; 4us; 32768us; 0us; 107us; 15us; 93us; 16us; 92us; 17us; 106us; 3us; 32768us; 0us; 107us; 6us; 9us; 17us; 106us; 1us; 32768us; 3us; 10us; 2us; 32768us; 15us; 93us; 16us; 92us; 1us; 32768us; 4us; 12us; 0us; 16386us; 0us; 16387us; 0us; 16388us; 2us; 32768us; 15us; 93us; 16us; 92us; 1us; 32768us; 4us; 17us; 1us; 16390us; 5us; 18us; 2us; 32768us; 15us; 93us; 16us; 92us; 1us; 32768us; 6us; 20us; 0us; 16389us; 0us; 16391us; 0us; 16392us; 0us; 16393us; 0us; 16394us; 4us; 32768us; 0us; 107us; 15us; 93us; 16us; 92us; 17us; 106us; 3us; 32768us; 0us; 107us; 2us; 27us; 17us; 106us; 3us; 32768us; 0us; 107us; 3us; 28us; 17us; 106us; 2us; 32768us; 15us; 93us; 16us; 92us; 1us; 32768us; 4us; 30us; 0us; 16395us; 0us; 16396us; 0us; 16397us; 0us; 16398us; 0us; 16399us; 0us; 16400us; 3us; 32768us; 0us; 107us; 11us; 37us; 17us; 106us; 2us; 16402us; 15us; 93us; 16us; 92us; 0us; 16401us; 0us; 16403us; 2us; 16409us; 15us; 93us; 16us; 92us; 4us; 32768us; 0us; 107us; 12us; 45us; 13us; 42us; 17us; 106us; 6us; 32768us; 0us; 107us; 7us; 54us; 14us; 94us; 15us; 93us; 16us; 92us; 17us; 106us; 0us; 16404us; 0us; 16405us; 6us; 32768us; 0us; 107us; 7us; 54us; 14us; 94us; 15us; 93us; 16us; 92us; 17us; 106us; 0us; 16406us; 0us; 16407us; 0us; 16408us; 2us; 16409us; 15us; 93us; 16us; 92us; 0us; 16410us; 3us; 16411us; 7us; 58us; 15us; 93us; 16us; 92us; 0us; 16412us; 0us; 16413us; 4us; 32768us; 7us; 54us; 14us; 94us; 15us; 93us; 16us; 92us; 1us; 32768us; 8us; 56us; 0us; 16414us; 0us; 16415us; 4us; 32768us; 7us; 54us; 14us; 94us; 15us; 93us; 16us; 92us; 1us; 32768us; 8us; 60us; 0us; 16416us; 1us; 32768us; 12us; 62us; 2us; 32768us; 15us; 93us; 16us; 92us; 0us; 16417us; 3us; 32768us; 0us; 107us; 11us; 65us; 17us; 106us; 2us; 16419us; 15us; 93us; 16us; 92us; 0us; 16418us; 0us; 16420us; 0us; 16421us; 3us; 32768us; 0us; 107us; 11us; 70us; 17us; 106us; 2us; 16423us; 15us; 93us; 16us; 92us; 0us; 16422us; 0us; 16424us; 2us; 32768us; 15us; 93us; 16us; 92us; 3us; 32768us; 0us; 107us; 12us; 75us; 17us; 106us; 3us; 16428us; 7us; 81us; 15us; 93us; 16us; 92us; 0us; 16425us; 0us; 16426us; 0us; 16427us; 1us; 16428us; 7us; 81us; 0us; 16429us; 3us; 32768us; 0us; 107us; 15us; 82us; 17us; 106us; 3us; 32768us; 0us; 107us; 10us; 83us; 17us; 106us; 4us; 32768us; 0us; 107us; 15us; 93us; 16us; 92us; 17us; 106us; 3us; 32768us; 0us; 107us; 8us; 85us; 17us; 106us; 0us; 16430us; 0us; 16431us; 0us; 16432us; 0us; 16433us; 0us; 16434us; 2us; 16436us; 15us; 93us; 16us; 92us; 0us; 16435us; 0us; 16437us; 0us; 16438us; 1us; 32768us; 15us; 95us; 2us; 32768us; 15us; 93us; 16us; 92us; 3us; 32768us; 7us; 99us; 15us; 93us; 16us; 92us; 3us; 16439us; 7us; 103us; 15us; 93us; 16us; 92us; 0us; 16440us; 4us; 32768us; 7us; 54us; 14us; 94us; 15us; 93us; 16us; 92us; 1us; 32768us; 8us; 101us; 0us; 16441us; 0us; 16442us; 4us; 32768us; 7us; 54us; 14us; 94us; 15us; 93us; 16us; 92us; 1us; 32768us; 8us; 105us; 0us; 16443us; 0us; 16444us; 0us; 16445us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 4us; 5us; 9us; 10us; 15us; 19us; 24us; 29us; 33us; 35us; 38us; 40us; 41us; 42us; 43us; 46us; 48us; 50us; 53us; 55us; 56us; 57us; 58us; 59us; 60us; 65us; 69us; 73us; 76us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 88us; 91us; 92us; 93us; 96us; 101us; 108us; 109us; 110us; 117us; 118us; 119us; 120us; 123us; 124us; 128us; 129us; 130us; 135us; 137us; 138us; 139us; 144us; 146us; 147us; 149us; 152us; 153us; 157us; 160us; 161us; 162us; 163us; 167us; 170us; 171us; 172us; 175us; 179us; 183us; 184us; 185us; 186us; 188us; 189us; 193us; 197us; 202us; 206us; 207us; 208us; 209us; 210us; 211us; 214us; 215us; 216us; 217us; 219us; 222us; 226us; 230us; 231us; 236us; 238us; 239us; 240us; 245us; 247us; 248us; 249us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 9us; 6us; 5us; 9us; 6us; 4us; 3us; 2us; 1us; 6us; 4us; 3us; 2us; 1us; 1us; 3us; 2us; 2us; 4us; 4us; 4us; 4us; 3us; 0us; 2us; 1us; 1us; 1us; 3us; 2us; 4us; 3us; 3us; 2us; 2us; 1us; 3us; 2us; 2us; 4us; 4us; 3us; 0us; 2us; 5us; 5us; 4us; 3us; 2us; 2us; 1us; 1us; 1us; 4us; 1us; 3us; 2us; 4us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 2us; 2us; 2us; 2us; 2us; 2us; 2us; 2us; 3us; 3us; 3us; 3us; 3us; 4us; 5us; 5us; 5us; 6us; 6us; 6us; 6us; 6us; 7us; 7us; 8us; 8us; 9us; 9us; 9us; 9us; 10us; 11us; 11us; 11us; 12us; 13us; 13us; 13us; 14us; 14us; 14us; 15us; 15us; 16us; 16us; 16us; 16us; 16us; 17us; 17us; 18us; 18us; 19us; 20us; 20us; 20us; 20us; 21us; 21us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 49152us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16386us; 16387us; 16388us; 65535us; 65535us; 65535us; 65535us; 65535us; 16389us; 16391us; 16392us; 16393us; 16394us; 65535us; 65535us; 65535us; 65535us; 65535us; 16395us; 16396us; 16397us; 16398us; 16399us; 16400us; 65535us; 65535us; 16401us; 16403us; 65535us; 65535us; 65535us; 16404us; 16405us; 65535us; 16406us; 16407us; 16408us; 65535us; 16410us; 65535us; 16412us; 16413us; 65535us; 65535us; 16414us; 16415us; 65535us; 65535us; 16416us; 65535us; 65535us; 16417us; 65535us; 65535us; 16418us; 16420us; 16421us; 65535us; 65535us; 16422us; 16424us; 65535us; 65535us; 65535us; 16425us; 16426us; 16427us; 65535us; 16429us; 65535us; 65535us; 65535us; 65535us; 16430us; 16431us; 16432us; 16433us; 16434us; 65535us; 16435us; 16437us; 16438us; 65535us; 65535us; 65535us; 65535us; 16440us; 65535us; 65535us; 16441us; 16442us; 65535us; 65535us; 16443us; 16444us; 16445us; |]
let _fsyacc_reductions ()  =    [| 
# 305 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : SynTInstance)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startTInstance));
# 314 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : SynPInstance)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startPInstance));
# 323 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priorities)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'Automaton)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 88 "HORSParser.fsy"
                                                                                           { HORS = _2; Automaton = { Priorities = _5; Transitions = _8 } } 
                   )
# 88 "HORSParser.fsy"
                 : SynPInstance));
# 336 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priorities)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 89 "HORSParser.fsy"
                                                                                           reportError parseState "expected \"%ENDP\"." 6 
                   )
# 89 "HORSParser.fsy"
                 : SynPInstance));
# 349 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 90 "HORSParser.fsy"
                                                                                           reportError parseState "expected a priority assignment." 5 
                   )
# 90 "HORSParser.fsy"
                 : SynPInstance));
# 361 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Automaton)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priorities)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 91 "HORSParser.fsy"
                                                                                           { HORS = _2; Automaton = { Priorities = _8; Transitions = _5 } } 
                   )
# 91 "HORSParser.fsy"
                 : SynPInstance));
# 374 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Automaton)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 92 "HORSParser.fsy"
                                                                                           { HORS = _2; Automaton = mkPAuto _5 } 
                   )
# 92 "HORSParser.fsy"
                 : SynPInstance));
# 386 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 93 "HORSParser.fsy"
                                                                                           reportError parseState "expected \"%BEGINP\" or \"BEGINA\"." 4 
                   )
# 93 "HORSParser.fsy"
                 : SynPInstance));
# 398 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 94 "HORSParser.fsy"
                                                                                           reportError parseState "expected \"%ENDG\"." 3 
                   )
# 94 "HORSParser.fsy"
                 : SynPInstance));
# 410 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 95 "HORSParser.fsy"
                                                                                           reportError parseState "expected a rule." 2 
                   )
# 95 "HORSParser.fsy"
                 : SynPInstance));
# 421 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 96 "HORSParser.fsy"
                                                                                           reportError parseState "expected \"%BEGING\"." 1 
                   )
# 96 "HORSParser.fsy"
                 : SynPInstance));
# 432 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Automaton)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 99 "HORSParser.fsy"
                                                                  { HORS = _2; Automaton = { Transitions = _5 } } 
                   )
# 99 "HORSParser.fsy"
                 : SynTInstance));
# 444 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 100 "HORSParser.fsy"
                                                                  reportError parseState "expected \"%BEGINA\"." 4 
                   )
# 100 "HORSParser.fsy"
                 : SynTInstance));
# 456 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Hors)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 101 "HORSParser.fsy"
                                                                  reportError parseState "expected \"%ENDG\"." 3 
                   )
# 101 "HORSParser.fsy"
                 : SynTInstance));
# 468 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 102 "HORSParser.fsy"
                                                                  reportError parseState "expected a rule." 2 
                   )
# 102 "HORSParser.fsy"
                 : SynTInstance));
# 479 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 103 "HORSParser.fsy"
                                                                  reportError parseState "expected \"%BEGING\"." 1 
                   )
# 103 "HORSParser.fsy"
                 : SynTInstance));
# 490 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'HorsRules)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 106 "HORSParser.fsy"
                                           SynScheme.init _1 dataItems 
                   )
# 106 "HORSParser.fsy"
                 : 'Hors));
# 501 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'HorsRule)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'HorsRules)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 109 "HORSParser.fsy"
                                                           _1 :: _3 
                   )
# 109 "HORSParser.fsy"
                 : 'HorsRules));
# 513 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'HorsRule)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 110 "HORSParser.fsy"
                                                           [_1] 
                   )
# 110 "HORSParser.fsy"
                 : 'HorsRules));
# 524 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'HorsRule)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 111 "HORSParser.fsy"
                                                           reportError parseState "expected \'.\' at end of rule." 2 
                   )
# 111 "HORSParser.fsy"
                 : 'HorsRules));
# 536 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vars)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 114 "HORSParser.fsy"
                                                          { Head = _1; Vars = _2; Rhs = _4 } 
                   )
# 114 "HORSParser.fsy"
                 : 'HorsRule));
# 549 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vars)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 115 "HORSParser.fsy"
                                                          reportError parseState "expected a term on the RHS of rule." 4 
                   )
# 115 "HORSParser.fsy"
                 : 'HorsRule));
# 562 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vars)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 116 "HORSParser.fsy"
                                                          { Head = _1; Vars = _2; Rhs = _4 } 
                   )
# 116 "HORSParser.fsy"
                 : 'HorsRule));
# 575 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vars)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 117 "HORSParser.fsy"
                                                          reportError parseState "expected a term on the RHS of rule." 4 
                   )
# 117 "HORSParser.fsy"
                 : 'HorsRule));
# 588 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vars)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 118 "HORSParser.fsy"
                                                          reportError parseState "expected \'=\' followed by RHS." 3 
                   )
# 118 "HORSParser.fsy"
                 : 'HorsRule));
# 601 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 121 "HORSParser.fsy"
                                      [] 
                   )
# 121 "HORSParser.fsy"
                 : 'Vars));
# 611 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vars)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 122 "HORSParser.fsy"
                                      _1 :: _2 
                   )
# 122 "HORSParser.fsy"
                 : 'Vars));
# 623 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Exp)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 127 "HORSParser.fsy"
                                                    _1 
                   )
# 127 "HORSParser.fsy"
                 : 'Term));
# 634 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Case)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 128 "HORSParser.fsy"
                                                    _1 
                   )
# 128 "HORSParser.fsy"
                 : 'Term));
# 645 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 131 "HORSParser.fsy"
                                                    SynId _1 
                   )
# 131 "HORSParser.fsy"
                 : 'Exp));
# 656 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 132 "HORSParser.fsy"
                                                    _2 
                   )
# 132 "HORSParser.fsy"
                 : 'Exp));
# 667 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Exp)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 133 "HORSParser.fsy"
                                         SynApp (_1, SynId _2) 
                   )
# 133 "HORSParser.fsy"
                 : 'Exp));
# 679 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Exp)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 134 "HORSParser.fsy"
                                                    SynApp (_1, _3) 
                   )
# 134 "HORSParser.fsy"
                 : 'Exp));
# 691 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 137 "HORSParser.fsy"
                                                  mkPrio parseState _1 _3 
                   )
# 137 "HORSParser.fsy"
                 : 'Priority));
# 703 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priority)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priorities)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 140 "HORSParser.fsy"
                                                    _1 :: _3 
                   )
# 140 "HORSParser.fsy"
                 : 'Priorities));
# 715 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priority)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 141 "HORSParser.fsy"
                                                    [_1] 
                   )
# 141 "HORSParser.fsy"
                 : 'Priorities));
# 726 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Priority)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 142 "HORSParser.fsy"
                                                    reportError parseState "expected \'.\' at end of priority specification." 2 
                   )
# 142 "HORSParser.fsy"
                 : 'Priorities));
# 738 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Transitions)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 145 "HORSParser.fsy"
                                             _1 
                   )
# 145 "HORSParser.fsy"
                 : 'Automaton));
# 749 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Transition)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Transitions)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 148 "HORSParser.fsy"
                                                                _1 :: _3 
                   )
# 148 "HORSParser.fsy"
                 : 'Transitions));
# 761 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Transition)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 149 "HORSParser.fsy"
                                                  [_1] 
                   )
# 149 "HORSParser.fsy"
                 : 'Transitions));
# 772 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Transition)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 150 "HORSParser.fsy"
                                                               reportError parseState "expected \'.\' at end of transition." 2 
                   )
# 150 "HORSParser.fsy"
                 : 'Transitions));
# 784 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'IntStatePairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 153 "HORSParser.fsy"
                                                                { State = _1; Symbol = _2; Succs = _4 } 
                   )
# 153 "HORSParser.fsy"
                 : 'Transition));
# 797 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'States)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 154 "HORSParser.fsy"
                                                                mkDetTrans _1 _2 _4 
                   )
# 154 "HORSParser.fsy"
                 : 'Transition));
# 810 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 155 "HORSParser.fsy"
                                                                reportError parseState "expected \"->\"." 3 
                   )
# 155 "HORSParser.fsy"
                 : 'Transition));
# 823 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 158 "HORSParser.fsy"
                                    [] 
                   )
# 158 "HORSParser.fsy"
                 : 'IntStatePairs));
# 833 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IntStatePair)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IntStatePairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 159 "HORSParser.fsy"
                                                      _1 :: _2 
                   )
# 159 "HORSParser.fsy"
                 : 'IntStatePairs));
# 845 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Int32)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 162 "HORSParser.fsy"
                                                          (_2, _4) 
                   )
# 162 "HORSParser.fsy"
                 : 'IntStatePair));
# 857 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Int32)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 163 "HORSParser.fsy"
                                                          reportError parseState "expected \')\'." 5 
                   )
# 163 "HORSParser.fsy"
                 : 'IntStatePair));
# 870 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Int32)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 164 "HORSParser.fsy"
                                                          reportError parseState "expected state indicating requirement on this argument index." 4
                   )
# 164 "HORSParser.fsy"
                 : 'IntStatePair));
# 882 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Int32)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 165 "HORSParser.fsy"
                                                          reportError parseState "expected \',\'." 3 
                   )
# 165 "HORSParser.fsy"
                 : 'IntStatePair));
# 894 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 166 "HORSParser.fsy"
                                                          reportError parseState "expected natural number indicating argument index." 2 
                   )
# 166 "HORSParser.fsy"
                 : 'IntStatePair));
# 905 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'States)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 169 "HORSParser.fsy"
                                         _1 :: _2 
                   )
# 169 "HORSParser.fsy"
                 : 'States));
# 917 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 170 "HORSParser.fsy"
                                         [_1] 
                   )
# 170 "HORSParser.fsy"
                 : 'States));
# 928 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : String)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 173 "HORSParser.fsy"
                                    mkIdent (_1, parseState.InputStartPosition 1) 
                   )
# 173 "HORSParser.fsy"
                 : 'Ident));
# 939 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Int32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 174 "HORSParser.fsy"
                                    mkData (_1, parseState.InputStartPosition 1) 
                   )
# 174 "HORSParser.fsy"
                 : 'Ident));
# 950 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Int32)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Alternatives)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 177 "HORSParser.fsy"
                                                       SynCase (_2, SynId _3, _4) 
                   )
# 177 "HORSParser.fsy"
                 : 'Case));
# 963 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 180 "HORSParser.fsy"
                                                            [SynId _1] 
                   )
# 180 "HORSParser.fsy"
                 : 'Alternatives));
# 974 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 181 "HORSParser.fsy"
                                                            [_2] 
                   )
# 181 "HORSParser.fsy"
                 : 'Alternatives));
# 985 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Alternatives)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 182 "HORSParser.fsy"
                                                  (SynId _2) :: _1 
                   )
# 182 "HORSParser.fsy"
                 : 'Alternatives));
# 997 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Alternatives)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 183 "HORSParser.fsy"
                                                            _3 :: _1 
                   )
# 183 "HORSParser.fsy"
                 : 'Alternatives));
# 1009 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 186 "HORSParser.fsy"
                                 true 
                   )
# 186 "HORSParser.fsy"
                 : 'Recover));
# 1019 "HORSParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 187 "HORSParser.fsy"
                                 false 
                   )
# 187 "HORSParser.fsy"
                 : 'Recover));
|]
# 1030 "HORSParser.fs"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 20;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let TInstance lexer lexbuf : SynTInstance =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
let PInstance lexer lexbuf : SynPInstance =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 2))
