﻿module HORSSyntax.Parser

open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing

let private parse (fn: String) (f: (LexBuffer<Char> -> HORSParser.token) -> LexBuffer<Char> -> 'a) (s: String) : 'a =
  let lexbuf = LexBuffer<Char>.FromString s
  do lexbuf.EndPos <- { pos_bol = 0; pos_fname=fn; pos_cnum=0; pos_lnum=1 }
  f HORSLexer.tokenizeMain lexbuf

let tinstance fn   = parse fn HORSParser.TInstance
let pinstance fn   = parse fn HORSParser.PInstance
//let hors fn       = parse fn HORSParser.Hors
//let automaton fn  = parse fn HORSParser.Automaton
//let rule fn       = parse fn HORSParser.HorsRule
//let transition fn = parse fn HORSParser.Transition
//let term fn       = parse fn HORSParser.Term