﻿namespace HORSSyntax

open Identifier

[<CustomEquality>]
[<CustomComparison>]
[<StructuredFormatDisplay("{Str}")>]
type SynIdent = 
  {
    Str: String
    Pos: String * Int32 * Int32
  }

  override this.ToString () =
    this.Str

  override this.Equals that =
    Object.eqHack (fun x -> x.Str) this that

  override this.GetHashCode() = 
    hash this.Str

  member this.CompareTo that = 
    Object.compHack (fun x -> x.Str) this that
      
  interface System.IComparable with
    member this.CompareTo that = this.CompareTo that

[<CompilationRepresentation(CompilationRepresentationFlags.ModuleSuffix)>]
module SynIdent =

  module Parsers =
    
    open FParsec
    open Parsers

    let pSynIdent : Parser<SynIdent> =
      sparse {
        let! p = getPosition
        let! s = many1Satisfy Ident.Parsers.isIdChar
        return
          {
            Str = s
            Pos = (p.StreamName, int32 p.Line, int32 p.Column)
          }
      }
