﻿#load "References.fsx"

let notRule = "Not b = if b false true."
let orRule = "Or b1 b2 = if b1 true b2."
let mainRule = "S = br (if (Not (L1 (L1 true))) err ok) (if (Not (L1 (L1 false))) err ok)."
let bitRule = "Bits a b c g = if (Or (Not a) (Or (Not b) (Not c))) (if (Not a) (Bits true b c g) (if (Not b) (Bits false true c g) (Bits false false true g))) g."
let levelRule n =
  sprintf "L%d g = Not (if g (Bits false false false g) (L%d (L%d g)))." n (n+1) (n+1)
let lastLevel n =
  sprintf "L%d g = Not (if g (Bits false false false g) g)." n
let mkT n =
  let levels =
    seq { for i in 1 .. (n-1) do yield levelRule i }
  let lines =
    ["%BEGING"]
    @ [mainRule; notRule; orRule; bitRule]
    @ List.ofSeq levels
    @ [lastLevel n]
    @ ["%ENDG"]
    @ [""]
    @ ["%BEGINA"]
    @ ["q0 ok -> ."]
    @ ["q0 if -> (1, qt) (2, q0)."]
    @ ["q0 if -> (1, qf) (3, q0)."]
    @ ["qt if -> (1, qt) (2, qt)."]
    @ ["qt if -> (1, qf) (3, qt)."]
    @ ["qf if -> (1, qt) (2, qf)."]
    @ ["qf if -> (1, qf) (3, qf)."]
    @ ["qt true -> ."]
    @ ["qf false -> ."]
    @ ["q0 br -> q0 q0."]
    @ ["%ENDA"]
  lines

let writeT dir n =
  let fn = sprintf "s%d.hrs" n
  let fp = System.IO.Path.Combine (dir, fn)
  let tx = mkT n
  System.IO.File.WriteAllLines (fp, tx)

writeT @"C:\Users\steven\SkyDrive\Projects\HORSBenchmarks\Bebop" 400

