﻿#load "References.fsx"

let mainProg = "
decl g;
void main()
begin
  level1();
  level1();
  if (!g) then
    reach: skip;
  else
    skip;
  fi
end
"

let level n = 
  sprintf
    "void level%d()
    begin
      decl a,b,c;
      if (g) then
        a,b,c := 0,0,0;
        while (!a|!b|!c) do
          if (!a) then
            a := 1;
          elsif (!b) then
            a,b := 0,1;
          else
            a,b,c := 0,0,1;
          fi
        od
      else
        level%d(); level%d();
      fi
      g := !g;
    end" 
    n 
    (n+1) 
    (n+1)

let lastlevel n =
  sprintf
    "void level%d()
    begin
      decl a,b,c;
      if (g) then
        a,b,c := 0,0,0;
        while (!a|!b|!c) do
          if (!a) then
            a := 1;
          elsif (!b) then
            a,b := 0,1;
          else
            a,b,c := 0,0,1;
          fi
        od
      else
        skip; skip;
      fi
      g := !g;
    end" 
    n 

let mkBP (n: Int) : List<String> =
  let levels =
    seq { for i in 1..(n-1) do yield level i }
  let lines =
    mainProg :: List.ofSeq levels @ [lastlevel n]
  List.intersperse lines "\n"

let writeT dir n =
  let fn = sprintf "t%d.bp" n
  let fp = System.IO.Path.Combine (dir, fn)
  let tx = mkBP n
  System.IO.File.WriteAllLines (fp, tx)

writeT @"C:\Users\ster\SkyDrive\Projects\HORSSyntax\Benchmarks\Bebop" 800
