﻿#load "References.fsx"

let notRule = "Not k b = _case 2 b (k 1) (k 0)."
let orRule = "Or k b1 b2 = _case 2 b1 (k 0) (k b2)."
let mainRule = "S = br (L1 (L1 (Not Check)) 0) (L1 (L1 (Not Check)) 1)."
let checkRule = "Check x = _case 2 x err ok."
let bitRule  = "Bits g a b c k = Not (Nota k g a b c) a."
let bitRule1 = "Nota k g a b c nota = Not (Notb k g a b c nota) b."
let bitRule2 = "Notb k g a b c nota notb = Not (Notc k g a b c nota notb) c."
let bitRule3 = "Notc k g a b c nota notb notc = Or (Or k a) b c."
let bitRule4 = "NotaWas0 g a b c k = Bits g 0 b c k."
let bitRule5 = "NotbWas0 g a b c k = Bits g 1 0 c k."
let bitRule6 = "NotcWas0 g a b c k = Bits g 1 1 0 k."
let bitRule8 = "WasAnyBit1 g k a b c nota notb notc orres = If orres (WhichBitWas1 g a b c nota notb notc) (App g) k."
let ifRule   = "If b s t k = _case 2 b (s k) (t k)."
let bitRule7 = "WhichBitWas1 g a b c nota notb notc k = If nota (NotaWas0 g a b c) (If notb (NotbWas0 g a b c) (NotcWas0 g a b c)) k."
let levelRule n = 
  sprintf "L%d k g = If g (Bits g 1 1 1) (L%dTwice g) (Not k)." n (n+1)
let levelTwiceRule n =
  sprintf "L%dTwice g k = L%d (L%d k) g." n n n
let appRule = "App x k = k x."
let lastLevel n =
  sprintf "L%d k g = If g (Bits g 1 1 1) (App g) (Not k)." n
let mkT n =
  let levelRules =
    seq { for i in 1 .. (n-1) do yield levelRule i }
  let levelTwiceRules =
    seq { for i in 1 .. n do yield levelTwiceRule i }
  let lines =
    ["%BEGING"]
    @ [mainRule; notRule; orRule; checkRule; bitRule; bitRule1; bitRule2; bitRule3; bitRule4; bitRule5; bitRule6; bitRule7; bitRule8; ifRule; appRule]
    @ List.ofSeq levelRules
    @ List.ofSeq levelTwiceRules
    @ [lastLevel n]
    @ ["%ENDG"]
    @ [""]
    @ ["%BEGINA"]
    @ ["q0 ok -> ."]
    @ ["q0 br -> q0 q0."]
    @ ["%ENDA"]
  lines

let writeT dir n =
  let fn = sprintf "t%d.hrs" n
  let fp = System.IO.Path.Combine (dir, fn)
  let tx = mkT n
  System.IO.File.WriteAllLines (fp, tx)

writeT @"C:\Users\ster\SkyDrive\Projects\HORSBenchmarks\Bebop" 2
