
#load "AsyncChoice.fs"
open ModelCheckApp

let delayReturn n s = async {
    // Run a couple of async operations - F# checks for 
    // cancellation automatically when starting them
    do! Async.Sleep(n) 
    do! Async.Sleep(1)  
    printfn "returning %s" s
    return s }

// Run two 'delayReturn' workflows in parallel and return
// the result of the first one. Note that this only prints
// 'returning First!' (because the other workflow is cancelled)
Async.Choice [ delayReturn 1000 "First!"; delayReturn 500 "Second!" ]
|> Async.RunSynchronously