﻿
#I @"..\..\FSharpLibs\FParsec"
#r @"..\..\Utils\bin\Debug\Utils.dll"
#r @"..\..\RecScheme\bin\Debug\RecScheme.dll"
#r @"..\..\ModelCheckLib\bin\Debug\ModelCheckLib.dll"
#r "FParsecCS.dll"
#r "FParsec.dll"

#load "HORSCParser.fs"
#load "Parser.fs"

open RecScheme.Parsing
open HORSCParser

let pct = parse pSynCaseTerm

let t1 = pct "a b"
let t2 = pct "case(b1, (b1,a), (b2,b))"

let ph = Parser.parseHORSC

let h1 = "
{
zero : o,
pred : o -> o,
succ : o -> o,
0:d,
1:d
}
{
S --> case(H, (0,G succ), (1, G pred)),
H --> 0,
H --> H,
G g --> g zero
}
{
q0 succ --> q1,
q1 zero --> 
}
"

let h2 = "
{
zero : o,
pred : o -> o,
succ : o -> o,
0:d,
1:d
}
{
S --> case(case(0,(0,0),(1,0)), (0,case(H, (0,G succ), (1,G succ))), (1, G pred)),
H --> 0,
H --> H,
G g --> case(0,(0,g zero),(1,g zero))
}
{
q0 succ --> q1,
q1 zero --> 
}
"

let g, calA = Parser.parse (System.IO.File.ReadAllText dual)

let m : TvMap.T<CalD.DerivT> = TvMap.empty ()

let init g calA =
  Algorithm.init g calA
  
let run calR calA m d = List.iter (Algorithm.expand calR calA m) (CalD.openNodes m d)

let d = init g calA

let r () = run g.ruleset calA m d; CalD.getTrace m d

