﻿
#load "References.fsx"

#load "Cfg.fs"
#load "Symbol.fs"
#load "TvType.fs"
#load "IntType.fs"
#load "Classification.fs"
#load "Automaton.fs"
#load "TermCase.fs"
#load "BasicTypes.fs"
#load "HORSC.fs"


open ModelCheckLib

let x1 = Automaton.parse "q0 a -> (1, q0) (2, q0), q0 b -> (1, q0), q0 c -> "
//let x2 = Automaton.parse "q0 a -> (1, q0) (2, q0), q0 b -> (1, q0), q0 c -> , q0 a -> (1, q1) (1, q3) (2, q1)"

let a = x1
Classification.tmap
let ta = a.alphabet.MinimumElement
let q0 = a.initial
Map.tryFind (q0,ta) a.transitions


let x1' = Automaton.op x1


let x2 = Automaton.parse "q0 a -> (1, q0) (2, q0), q0 b -> (1, q0), q0 c -> , q0 a -> (1, q1) (1, q3) (2, q1)"

let q3 = List.head <| Map.domainList x2.states
let x3 = { x2 with states = Map.add q3 false x2.states }


let x4 = Automaton.parse  """
q0 br -> (1,q0) (1,q0),
qr br -> (1,qr) (1,qr),
qw br -> (1,qw) (1,qw),
qrw br -> (1,qrw (1,qrw),
q0 newr -> (1,qr),
qr read -> (1,qr),
qr close -> (1,qc),
q0 neww -> (1,qw),
qw write -> (1,qw),
qw close -> (1,qc),
qw newr -> (1,qrw),
qr neww -> (1,qrw),
qrw read -> (1,qrw),
qrw write -> (1,qrw),
qrw close -> (1,qrw),
qc end ->,
q0 end ->,
qrw end ->,
"""

//acceptance {
//   accept : qw qrw qc;
//   reject : qr;
//   accept : q0;
//}

let x5 = Automaton.parse """q0 br -> q0 q0"""

Parsers.parse HORSSyntax.SynAutomaton.Parsers.pAutomaton """q0 br -> q0 q0"""

let b1 = 
  let a = Automaton.parse "q0 a -> (1, q0) (2, q0), q0 b -> (1, q0), q0 c -> , q0 a -> (1, q1) (1, q3) (2, q1)"
  let res = Automaton.op a
  let exp = Automaton.parse "q0 a -> (1, q0) (1, q1), q0 a -> (1, q0) (1, q3), q0 a -> (1, q0) (2, q1), q0 a -> (2, q0) (1, q1), q0 a -> (2, q0) (1, q3), q0 a -> (2, q0) (2, q1), q0 b -> (1, q0)"
  Map.map (fun _ e -> set e) res.transitions = Map.map (fun _ e -> set e) exp.transitions