
#I "../FSharpLibs/FSPowerPackCLR4SP1"
#load "References.fsx"
#load "Cfg.fs"
#load "ChoiceTree.fs"


open ModelCheckLib

let displayDot s =
  //IO.writeAll "d:/dev/icfp12tool/ModelCheckApp/temp.dot" s
  IO.writeAll "/users/robnea/dev/toolicfp2012/ModelCheckApp/temp.dot" s
  //System.Diagnostics.Process.Start("acsview.py", "./temp.dot")

let showCt ct = ChoiceTree.toDot ct |> displayDot

let c () = ChoiceTree.empty ()

//
//let ct = c ()
//
//do ChoiceTree.populate ct false 2
//do ChoiceTree.populate ct.Children.[0] false 2
//do ChoiceTree.populate ct.Children.[0].Children.[1] true 2
//do ChoiceTree.populate ct.Children.[1] true 2
//do ChoiceTree.populate ct.Children.[1].Children.[0] true 2


let ct2 = c ()
let ct3 = c ()
let ct4 = c ()
let ct5 = c ()
let ct6 = ChoiceTree.addChildren (c ())
                                 true
                                 [ ct2; ct3 ]
let ct7 = c ()

let ct8 = ChoiceTree.addChildren (c ())
                                 false
                                 [ ct5 ]

let ct1 = ChoiceTree.addChildren
            (c ())
            false
            [ ChoiceTree.addChildren (c ())
                                      false
                                      [ ct6
                                        ChoiceTree.addChildren (c ())
                                                               true
                                                               [ c () ; c () ]]
              ChoiceTree.addChildren (c ())
                                      true
                                      [ ChoiceTree.addChildren (c ())
                                                               false
                                                               [ c (); ct4; c () ] 
                                        ct8 ] ]
                                      

let b1 = ct1.Parent = ct1

let b2 = ct2 = ct1 |> not

let b3 = ChoiceTree.lca ct5 ct5 = ct5

let b4 = ChoiceTree.lca ct5 ct1 = ct1

let b5 = ChoiceTree.compatible ct1 ct1

let b6 = ChoiceTree.compatible ct6 ct4 |> not

let b7 = ChoiceTree.compatible ct4 ct5

let b8 = ChoiceTree.compatible ct2 ct3

let b9 = ChoiceTree.compatible ct5 ct8


let rec leaves ct =
  match ct.Children with
  | [] -> [ct]
  | _ -> List.collect leaves ct.Children 

let rec allChildren ct =
  ct :: List.collect allChildren ct.Children

//showCt ct1

//let bronKerbosch3 elems =
//  let res = new ResizeArray<_>()
//  let emit r = ignore (res.Add(r))
//  
//  let rec aux r p x =  
//    if Set.isEmpty p && Set.isEmpty x then
//      emit r
//    else
//      let rec loop r p x =
//        if Set.isEmpty p then
//          ()
//        else
//          let v = Set.minElement p
//          
//          let ns = Set.filter (ChoiceTree.compatible v) (Set.remove v elems)
//          aux (Set.add v r) (Set.intersect p ns) (Set.intersect x ns)
//          loop r (Set.remove v p) (Set.add v x)
//          
//      loop r p x
//      
//  do aux Set.empty elems Set.empty
//  Seq.toList res
//
//let bronKerbosch2 elems =
//  let rec aux r p x =
//    seq {
//      if Set.isEmpty p && Set.isEmpty x then
//        yield r
//      else
//        let localp = ref p
//        let localx = ref x
//        for v in p do
//          let ns = Set.filter (ChoiceTree.compatible v) (Set.remove v elems)
//          yield! aux (Set.add v r) (Set.intersect !localp ns) (Set.intersect !localx ns)
//          localp := Set.remove v p
//          localx := Set.add v x
//    }
//      
//  aux Set.empty elems Set.empty
//
//
//let bronKerbosch elems =
//  //let res = new HashSet<_>()
//  //let emit r = ignore (res.Add(r))
//  
//  let rec aux r p x =
//    seq {
//      if Set.isEmpty p && Set.isEmpty x then
//        yield r
//      else
//        let rec loop r p x =
//          seq {
//            if Set.isEmpty p then
//              ()
//            else
//              let v = Set.minElement p
//                    
//              let ns = Set.filter (ChoiceTree.compatible v) (Set.remove v elems)
//              yield! aux (Set.add v r) (Set.intersect p ns) (Set.intersect x ns)
//              yield! loop r (Set.remove v p) (Set.add v x)
//          }
//        yield! loop r p x
//    }
//      
//  aux Set.empty elems Set.empty
//  //set res

let bronKerbosch elems =
  let res = new HashSet<_>()
  let emit r = ignore (res.Add(r))
    
  let rec aux r p x =  
    if Set.isEmpty p && Set.isEmpty x then
      emit r
    else
      let rec loop r p x =
        if Set.isEmpty p then
          ()
        else
          let v = Set.minElement p

          let ns = Set.filter (ChoiceTree.compatible v) (Set.remove v elems)
          aux (Set.add v r) (Set.intersect p ns) (Set.intersect x ns)
          loop r (Set.remove v p) (Set.add v x)
        
      // Pivot on u    
//        let u = Set.minElement (Set.union p x)
//        let ns = Set.filter (compatible u) (Set.remove u elems)
//        loop r (Set.difference p ns) x
        
      loop r p x
  do aux Set.empty elems Set.empty
  set res


let bronKerbosch2 (elems: Set<'a>) (neighbours: 'a -> 'a -> bool) =
  let res = new HashSet<_>()
  let emit r = ignore (res.Add(r))
    
  let rec aux r p x =  
    if Set.isEmpty p && Set.isEmpty x then
      emit r
    else
      let rec loop r p x =
        if Set.isEmpty p then
          ()
        else
          let v = Set.minElement p

          let p' = Set.filter (neighbours v) p |> Set.remove v
          let x' = Set.filter (neighbours v) x

          aux (Set.add v r) p' x'
          loop r (Set.remove v p) (Set.add v x)
        
      // Pivot on u    
//        let u = Set.minElement (Set.union p x)
//        let ns = Set.filter (compatible u) (Set.remove u elems)
//        loop r (Set.difference p ns) x
        
      loop r p x
  do aux Set.empty elems Set.empty
  set res


let bronKerbosch3 (elems: Set<'a>) (minBy: 'a -> 'b) (neighbours: 'a -> 'a -> bool) =
  let res = new HashSet<_>()
  let emit r = ignore (res.Add(r))
    
  let rec aux r p x =  
    if Set.isEmpty p && Set.isEmpty x then
      emit r
    else
      let mutable p = p
      let mutable x = x
      
      let u =
        if p.IsEmpty then (Seq.minBy minBy x)
        elif x.IsEmpty then (Seq.minBy minBy p)
        else min (Seq.minBy minBy p) (Seq.minBy minBy x)
        
      for v in (Set.filter (fun v -> u = v || neighbours u v |> not) p) do
        let p' = Set.filter (neighbours v) (Set.remove v p)
        let x' = Set.filter (neighbours v) x

        aux (Set.add v r) p' x'
        p <- Set.remove v p
        x <- Set.add v x

  do aux Set.empty elems Set.empty
  set res


let p = leaves ct1|>set
let x = Set.empty
let u = Set.minElement (Set.union p x)
let ns = Set.filter (ChoiceTree.compatible u) (Set.remove u p)
Set.difference p ns


bronKerbosch (leaves ct1|>set) |> Seq.toList
bronKerbosch2 (leaves ct1|>set) (ChoiceTree.compatible) |> Seq.toList
bronKerbosch3 (leaves ct1|>set) (fun ct -> ct.Id) (ChoiceTree.compatible) |> Seq.toList

bronKerbosch2 (allChildren ct1|>set) |> Seq.toList

ChoiceTree.lca ct5 ct1 |> showCt

//ChoiceTree.toDot ct5 |> displayDot



let nodes = set [1;2;3;4;5;6]

let m =
  [
    1,2
    1,5
    2,1
    2,3
    2,5
    3,2
    3,4
    4,3
    4,5
    4,6
    5,1
    5,2
    5,4
    6,4
  ] |> set

let neighbours x y = Set.contains (x,y) m

bronKerbosch2 nodes neighbours
bronKerbosch3 nodes neighbours

