#I "../FSharpLibs/FSPowerPackCLR4SP1"
#load "References.fsx"

#load "Timing.fs"
#load "Cfg.fs"
#load "Symbol.fs"
#load "TvType.fs"
#load "IntType.fs"
#load "Classification.fs"
#load "TermCase.fs"
#load "BasicTypes.fs"

open ModelCheckLib
open HORSSyntax.Parser
open HORSSyntax
open Parsers

let pState : Parser<State> = Identifier.Ident.Parsers.pIdent --> fun id -> { name = id }

let state = parse pState

let q0 = state "q0" |> IntType.atom
let q1 = state "q1" |> IntType.atom

let ty1 = IntType.arrow (set [q0;q1]) q0
let ty2 = IntType.arrow (set [q0;q1]) q0

let physeq = LanguagePrimitives.PhysicalEquality

let b1 = physeq ty1 ty2

type Bar() =
  let g = ref 0
  
  member x.getg = !g
  
  member x.setg n = g := n

let bar1 = new Bar()
let bar2 = new Bar()
bar1.setg 5
bar1.getg
bar2.getg

