﻿module Continuation

// type Cont<'r,'a> = ('a -> 'r) -> 'r

// The type is equivalent to:
//   Cont<'r, 'a> -> ('a -> Cont<'r, 'b>) -> Cont<'r, 'b>
let bind (mv: ('a -> 'r) -> 'r) (f: 'a -> ('b -> 'r) -> 'r) (k: 'b -> 'r) : 'r = 
  mv (fun a -> f a k) 

// This type is equivalent to:
//   'a -> Cont<'r, 'a>
let ret (v: 'a) (k: 'a -> 'r) : 'r =
  k v

type Cont() =
  member this.Bind (mv, f) = bind mv f
  member this.Return v = ret v

let cps = new Cont()
