﻿module HashSet

let inline cardinality (s: HashSet<'a>) = s.Count

let product (xss: HashSet<HashSet<'a>>) (yss: HashSet<HashSet<'a>>) =
  let hs = HashSet()
  for ys in yss do
    for xs in xss do
      let xs' = HashSet<'a> xs
      do xs'.UnionWith ys
      ignore (hs.Add xs')
  hs

let productWith (p: 'a -> 'b -> 'c) (xs: HashSet<'a>) (ys: HashSet<'b>) : HashSet<'c> =
  let result = HashSet()
  do Seq.iter (fun x -> Seq.iter (fun y -> ignore <| result.Add (p x y)) ys) xs
  result

let union (x: HashSet<'a>) (y: HashSet<'a>) =
  let hs = HashSet(x)
  hs.UnionWith y
  hs