﻿module Option

/// mapDefault f x o evaluates to match o with None -> x | Some v -> f v
let mapDefault f x o =
  match o with
  | Some v -> f v
  | None   -> x

let ap2 (f: 'a -> 'b -> 'c) (x: Option<'a>) (y: Option<'b>) : Option<'c> =
  Option.bind (fun x' -> Option.bind (fun y' -> Some (f x' y')) y) x

let sequence (xs: List<Option<'a>>) : Option<List<'a>> =
  List.fold (fun ys o -> ap2 (fun z zs -> z::zs) o ys) (Some []) xs

let collect (xs: List<Option<'a>>) : List<'a> =
  List.fold (fun ys optx -> match optx with None -> ys | Some x -> x::ys) [] xs

let getDefault (x: Option<'a>) (d: 'a) : 'a =
  match x with
  | None   -> d
  | Some v -> v
