﻿module Set

let eq (s1: Set<'a>) (s2: Set<'a>) : Bool = 
  Set.isSubset s1 s2 && Set.isSubset s2 s1

let randkSubset (k: Int32) (s: Set<'a>) : Set<'a> =
  let rand = System.Random()
  if k >= Set.count s then s
  else
    let a = Set.toArray s
    let n = Array.length a
    for x in 1 .. n do
      let i = n - x
      let j = rand.Next(i)
      let t = a.[i]
      a.[i] <- a.[j]
      a.[j] <- t
    let newSet, _ = Array.fold (fun (s,m) x -> if m = 0 then (s, m) else (Set.add x s, m-1)) (Set.empty, k) a
    newSet

let product (s1: Set<'a>) (s2: Set<'b>) : Set<'a * 'b> =
  set [for x in s1 do for y in s2 do yield (x, y)] 
