
[<AutoOpen>]
module Ubiquitous

// Type abbreviations for casing consistency
type String    = System.String
type Bool      = System.Boolean
type Int       = System.Int32
type Int32     = System.Int32
type Int64     = System.Int64
type UInt      = System.UInt32
type UInt32    = System.UInt32
type UInt64    = System.UInt64
type Char      = System.Char
type Object    = System.Object
type Byte      = System.Byte
type Float     = float
type Float32   = float32
type Array<'a> = Microsoft.FSharp.Core.array<'a>
type Seq<'a>   = Microsoft.FSharp.Collections.seq<'a>

type HashSet<'a>     = System.Collections.Generic.HashSet<'a>
type HashMap<'a,'b>  = System.Collections.Generic.Dictionary<'a, 'b>
type ResizeArray<'a> = System.Collections.Generic.List<'a>

// System.Collections.Generic.KeyNotFoundException is far too long to type out
// every time you have to handle the exception raised when a key is not in a map
type KeyNotFound = System.Collections.Generic.KeyNotFoundException

// Helper functions for printing
let toString x = sprintf  "%A" x
let print  x   =  printf  "%A" x
let printn x   =  printfn "%A" x

// Helper functions for composition
let curry   f  x y  = f (x,y)
let uncurry f (x,y) = f  x y

let flip f x y = f y x

let first  f (x,y) = (f x,y)
let second f (x,y) = (x,f y)